-- Package declaration
local _groupauras = _G["github.com/eandre/groupauras"] or {}
_G["github.com/eandre/groupauras"] = _groupauras

local builtins = _G.lunar_go_builtins

local _library = _G["github.com/eandre/groupauras/core/library"]
local _runner = _G["github.com/eandre/groupauras/core/runner"]
local _watcher = _G["github.com/eandre/groupauras/core/watcher"]
local _acedb = _G["github.com/eandre/groupauras/pkg/ace/acedb"]
local _aceaddon = _G["github.com/eandre/lunar-shim/ace/aceaddon"]

_groupauras.DB = nil
_groupauras.Library = nil
_groupauras.Runner = nil
_groupauras.Watcher = nil

_groupauras.Addon = {}

_groupauras.Addon._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_groupauras.Addon})
	local obj, err
	
	return self, nil
end

_groupauras.Addon._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	return nil
end

_groupauras.Addon.OnInitialize = function(a)
	_groupauras.DB = _acedb.New("GroupAurasDB", _groupauras.defaultConfig, "")
	_groupauras.Library = _library.New(_groupauras.DB.profile.Auras)
	_groupauras.Runner = _runner.New()
	_groupauras.Watcher = _watcher.New(_groupauras.Library, _groupauras.Runner)
end

builtins.add_init(function()
	_aceaddon.New("GroupAuras", setmetatable({  }, {__index=_groupauras.Addon}))
end)

_groupauras.debug = function()
end

