-- Package declaration
local _acecfg = _G["github.com/eandre/groupauras/pkg/ace/acecfg"] or {}
_G["github.com/eandre/groupauras/pkg/ace/acecfg"] = _acecfg

local builtins = _G.lunar_go_builtins


_acecfg.Info = {}

_acecfg.Info._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_acecfg.Info})
	local obj, err
	
	return self, nil
end

_acecfg.Info._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	return nil
end

_acecfg.Group = {}

_acecfg.Group._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_acecfg.Group})
	local obj, err
	
	self.Name = ""
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	self.Desc = ""
	if type(self.Desc) == type(tbl.Desc) then self.Desc = tbl.Desc end
	self.Order = 0
	if type(self.Order) == type(tbl.Order) then self.Order = tbl.Order end
	self.Type = ""
	if type(self.Type) == type(tbl.Type) then self.Type = tbl.Type end
	self.Validate = nil
	if type(self.Validate) == type(tbl.Validate) then self.Validate = tbl.Validate end
	self.Disabled = nil
	if type(self.Disabled) == type(tbl.Disabled) then self.Disabled = tbl.Disabled end
	self.Children = nil
	if type(self.Children) == type(tbl.Children) then self.Children = tbl.Children end
	return self, nil
end

_acecfg.Group._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.name) == type(tbl.name) then self.name = tbl.name end
	if type(self.desc) == type(tbl.desc) then self.desc = tbl.desc end
	if type(self.order) == type(tbl.order) then self.order = tbl.order end
	if type(self.type) == type(tbl.type) then self.type = tbl.type end
	if type(self.Validate) == type(tbl.Validate) then self.Validate = tbl.Validate end
	if type(self.disabled) == type(tbl.disabled) then self.disabled = tbl.disabled end
	if type(self.args) == type(tbl.args) then self.args = tbl.args end
	return nil
end

_acecfg.Group.option = function(g)
end

_acecfg.Range = {}

_acecfg.Range._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_acecfg.Range})
	local obj, err
	
	self.Name = ""
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	self.Desc = ""
	if type(self.Desc) == type(tbl.Desc) then self.Desc = tbl.Desc end
	self.Order = 0
	if type(self.Order) == type(tbl.Order) then self.Order = tbl.Order end
	self.Type = ""
	if type(self.Type) == type(tbl.Type) then self.Type = tbl.Type end
	self.Validate = nil
	if type(self.Validate) == type(tbl.Validate) then self.Validate = tbl.Validate end
	self.Disabled = nil
	if type(self.Disabled) == type(tbl.Disabled) then self.Disabled = tbl.Disabled end
	self.Min = 0
	if type(self.Min) == type(tbl.Min) then self.Min = tbl.Min end
	self.Max = 0
	if type(self.Max) == type(tbl.Max) then self.Max = tbl.Max end
	self.SoftMin = 0
	if type(self.SoftMin) == type(tbl.SoftMin) then self.SoftMin = tbl.SoftMin end
	self.SoftMax = 0
	if type(self.SoftMax) == type(tbl.SoftMax) then self.SoftMax = tbl.SoftMax end
	self.Step = 0
	if type(self.Step) == type(tbl.Step) then self.Step = tbl.Step end
	self.BigStep = 0
	if type(self.BigStep) == type(tbl.BigStep) then self.BigStep = tbl.BigStep end
	self.IsPercent = false
	if type(self.IsPercent) == type(tbl.IsPercent) then self.IsPercent = tbl.IsPercent end
	self.Get = nil
	if type(self.Get) == type(tbl.Get) then self.Get = tbl.Get end
	self.Set = nil
	if type(self.Set) == type(tbl.Set) then self.Set = tbl.Set end
	return self, nil
end

_acecfg.Range._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.name) == type(tbl.name) then self.name = tbl.name end
	if type(self.desc) == type(tbl.desc) then self.desc = tbl.desc end
	if type(self.order) == type(tbl.order) then self.order = tbl.order end
	if type(self.type) == type(tbl.type) then self.type = tbl.type end
	if type(self.Validate) == type(tbl.Validate) then self.Validate = tbl.Validate end
	if type(self.disabled) == type(tbl.disabled) then self.disabled = tbl.disabled end
	if type(self.min) == type(tbl.min) then self.min = tbl.min end
	if type(self.max) == type(tbl.max) then self.max = tbl.max end
	if type(self.softMin) == type(tbl.softMin) then self.softMin = tbl.softMin end
	if type(self.softMax) == type(tbl.softMax) then self.softMax = tbl.softMax end
	if type(self.step) == type(tbl.step) then self.step = tbl.step end
	if type(self.bigStep) == type(tbl.bigStep) then self.bigStep = tbl.bigStep end
	if type(self.isPercent) == type(tbl.isPercent) then self.isPercent = tbl.isPercent end
	if type(self.min) == type(tbl.min) then self.min = tbl.min end
	if type(self.min) == type(tbl.min) then self.min = tbl.min end
	return nil
end

_acecfg.Range.option = function(r)
end

_acecfg.Toggle = {}

_acecfg.Toggle._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_acecfg.Toggle})
	local obj, err
	
	self.Name = ""
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	self.Desc = ""
	if type(self.Desc) == type(tbl.Desc) then self.Desc = tbl.Desc end
	self.Order = 0
	if type(self.Order) == type(tbl.Order) then self.Order = tbl.Order end
	self.Type = ""
	if type(self.Type) == type(tbl.Type) then self.Type = tbl.Type end
	self.Validate = nil
	if type(self.Validate) == type(tbl.Validate) then self.Validate = tbl.Validate end
	self.Disabled = nil
	if type(self.Disabled) == type(tbl.Disabled) then self.Disabled = tbl.Disabled end
	self.Get = nil
	if type(self.Get) == type(tbl.Get) then self.Get = tbl.Get end
	self.Set = nil
	if type(self.Set) == type(tbl.Set) then self.Set = tbl.Set end
	return self, nil
end

_acecfg.Toggle._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.name) == type(tbl.name) then self.name = tbl.name end
	if type(self.desc) == type(tbl.desc) then self.desc = tbl.desc end
	if type(self.order) == type(tbl.order) then self.order = tbl.order end
	if type(self.type) == type(tbl.type) then self.type = tbl.type end
	if type(self.Validate) == type(tbl.Validate) then self.Validate = tbl.Validate end
	if type(self.disabled) == type(tbl.disabled) then self.disabled = tbl.disabled end
	if type(self.get) == type(tbl.get) then self.get = tbl.get end
	if type(self.set) == type(tbl.set) then self.set = tbl.set end
	return nil
end

_acecfg.Toggle.option = function(t)
end

_acecfg.Button = {}

_acecfg.Button._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_acecfg.Button})
	local obj, err
	
	self.Name = ""
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	self.Desc = ""
	if type(self.Desc) == type(tbl.Desc) then self.Desc = tbl.Desc end
	self.Order = 0
	if type(self.Order) == type(tbl.Order) then self.Order = tbl.Order end
	self.Type = ""
	if type(self.Type) == type(tbl.Type) then self.Type = tbl.Type end
	self.Validate = nil
	if type(self.Validate) == type(tbl.Validate) then self.Validate = tbl.Validate end
	self.Disabled = nil
	if type(self.Disabled) == type(tbl.Disabled) then self.Disabled = tbl.Disabled end
	self.Func = nil
	if type(self.Func) == type(tbl.Func) then self.Func = tbl.Func end
	return self, nil
end

_acecfg.Button._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.name) == type(tbl.name) then self.name = tbl.name end
	if type(self.desc) == type(tbl.desc) then self.desc = tbl.desc end
	if type(self.order) == type(tbl.order) then self.order = tbl.order end
	if type(self.type) == type(tbl.type) then self.type = tbl.type end
	if type(self.Validate) == type(tbl.Validate) then self.Validate = tbl.Validate end
	if type(self.disabled) == type(tbl.disabled) then self.disabled = tbl.disabled end
	if type(self.func) == type(tbl.func) then self.func = tbl.func end
	return nil
end

_acecfg.Button.option = function(b)
end

