-- Package declaration
local _draw = _G["github.com/eandre/groupauras/pkg/draw"] or {}
_G["github.com/eandre/groupauras/pkg/draw"] = _draw

local builtins = _G.lunar_go_builtins

local _widget = _G["github.com/eandre/lunar-wow/pkg/widget"]

_draw.animationState = {}

_draw.animationState._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_draw.animationState})
	local obj, err
	
	return self, nil
end

_draw.animationState._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	return nil
end

_draw.animationState.OnLoad = function(s, anim)
	s.regionParent = anim:GetRegionParent()
end

_draw.animationState.Alpha = function(s, anim)
	s.regionParent:SetAlpha(anim:GetProgress())
end

_draw.animationState.FullOpacity = function(s, anim)
	s.regionParent:SetAlpha(1)
end

_draw.animationState.HideParent = function(s, anim)
	anim:GetRegionParent():Hide()
end

_draw.animationState.Replay = function(s, anim)
	anim:Play()
end

