-- Package declaration
local _draw = _G["github.com/eandre/groupauras/pkg/draw"] or {}
_G["github.com/eandre/groupauras/pkg/draw"] = _draw

local builtins = _G.lunar_go_builtins

local _hbd = _G["github.com/eandre/lunar-shim/hbd"]
local _luamath = _G["github.com/eandre/lunar-wow/pkg/luamath"]
local _widget = _G["github.com/eandre/lunar-wow/pkg/widget"]
local _wow = _G["github.com/eandre/lunar-wow/pkg/wow"]

_draw.RotateMap = true

_draw.ZoomScale = 75

_draw.canvas = nil

_draw.maxSize = 0

builtins.add_init(function()
	local uiparent = _widget.UIParent()
	_draw.canvas = _widget.CreateFrame(uiparent)
	_draw.canvas:SetSize(uiparent:GetWidth(), uiparent:GetHeight())
	_draw.canvas:SetPoint("CENTER", uiparent, "CENTER", 0, 0)
	_draw.maxSize = _widget.UIParent():GetHeight() * 0.48
end)

_draw.displayOffset = function(x, y, inst)
	local px, py, i = _hbd.PlayerWorldPosition()
	if i ~= inst then
		return 0, 0, false
	end
	dx, dy = (x - px), (y - py)
	if _draw.RotateMap then
		local facing = _wow.PlayerFacing()
		local fsin = _luamath.Sin(facing)
		local fcos = _luamath.Cos(facing)
		local tx, ty = dx, dy
		dx = tx * fcos - ty * fsin
		dy = tx * fsin + ty * fcos
	end
	local ppy = _draw.pixelsPerYard()
	return (-dx) * ppy, dy * ppy, true
end

_draw.pixelsPerYard = function()
	return _draw.maxSize / _draw.ZoomScale
end

