-- Package declaration
local _draw = _G["github.com/eandre/groupauras/pkg/draw"] or {}
_G["github.com/eandre/groupauras/pkg/draw"] = _draw

local builtins = _G.lunar_go_builtins

local _widget = _G["github.com/eandre/lunar-wow/pkg/widget"]

_draw.textureDef = {}

_draw.textureDef._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_draw.textureDef})
	local obj, err
	
	self.Texture = ""
	if type(self.Texture) == type(tbl.Texture) then self.Texture = tbl.Texture end
	self.Blend = ""
	if type(self.Blend) == type(tbl.Blend) then self.Blend = tbl.Blend end
	self.TexCoords = nil
	if type(self.TexCoords) == type(tbl.TexCoords) then self.TexCoords = tbl.TexCoords end
	self.SizeScalar = 0
	if type(self.SizeScalar) == type(tbl.SizeScalar) then self.SizeScalar = tbl.SizeScalar end
	return self, nil
end

_draw.textureDef._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.Texture) == type(tbl.Texture) then self.Texture = tbl.Texture end
	if type(self.Blend) == type(tbl.Blend) then self.Blend = tbl.Blend end
	if type(self.TexCoords) == type(tbl.TexCoords) then self.TexCoords = tbl.TexCoords end
	if type(self.SizeScalar) == type(tbl.SizeScalar) then self.SizeScalar = tbl.SizeScalar end
	return nil
end

_draw.textureMap = { ["marker_1"] = { ["Texture"] = [=[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_1.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["marker_2"] = { ["Texture"] = [=[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_2.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["marker_3"] = { ["Texture"] = [=[Interface\TARGETINGFRAME\UI-RAIDTARGETINGICON_3.BLP]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["marker_4"] = { ["Texture"] = [=[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_4.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["marker_5"] = { ["Texture"] = [=[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_5.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["marker_6"] = { ["Texture"] = [=[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_6.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["marker_7"] = { ["Texture"] = [=[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_7.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["marker_8"] = { ["Texture"] = [=[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_8.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["cross2"] = { ["Texture"] = [=[Interface\RAIDFRAME\ReadyCheck-NotReady.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["check"] = { ["Texture"] = [=[Interface\RAIDFRAME\ReadyCheck-Ready.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["question"] = { ["Texture"] = [=[Interface\RAIDFRAME\ReadyCheck-Waiting.blp]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["targeting"] = { ["Texture"] = [=[Interface\Minimap\Ping\ping5.blp]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["highlight"] = { ["Texture"] = [=[Interface\AddOns\groupauras\assets\alert_circle]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["radius"] = { ["Texture"] = [=[Interface\AddOns\groupauras\assets\radius]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["radius_lg"] = { ["Texture"] = [=[Interface\AddOns\groupauras\assets\radius_lg]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["timer"] = { ["Texture"] = [=[Interface\AddOns\groupauras\assets\timer]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1.1}, ["glow"] = { ["Texture"] = [=[Interface\GLUES\MODELS\UI_Tauren\gradientCircle]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["party"] = { ["Texture"] = [=[Interface\MINIMAP\PartyRaidBlips]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0.525, 0.6, 0.04, 0.2 }, ["SizeScalar"] = 1}, ["tank"] = { ["Texture"] = [=[Interface\AddOns\groupauras\assets\roles]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0.5, 0.75, 0, 1 }, ["SizeScalar"] = 1}, ["dps"] = { ["Texture"] = [=[Interface\AddOns\groupauras\assets\roles]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0.75, 1, 0, 1 }, ["SizeScalar"] = 1}, ["healer"] = { ["Texture"] = [=[Interface\AddOns\groupauras\assets\roles]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0.25, 0.5, 0, 1 }, ["SizeScalar"] = 1}, ["fadecircle"] = { ["Texture"] = [=[Interface\AddOns\groupauras\assets\fadecircle]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["falloffcircle"] = { ["Texture"] = [=[Interface\AddOns\groupauras\assets\falloffcircle]=], ["Blend"] = _widget.BlendBlend, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["ring"] = { ["Texture"] = [=[SPELLS\CIRCLE]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["rune1"] = { ["Texture"] = [=[SPELLS\AURARUNE256.BLP]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["rune2"] = { ["Texture"] = [=[SPELLS\AURARUNE9.BLP]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["rune3"] = { ["Texture"] = [=[SPELLS\AURARUNE_A.BLP]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["rune4"] = { ["Texture"] = [=[SPELLS\AURARUNE_B.BLP]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0.032, 0.959, 0.035, 0.959 }, ["SizeScalar"] = 1}, ["paw"] = { ["Texture"] = [=[SPELLS\Agility_128.blp]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0.124, 0.876, 0.091, 0.903 }, ["SizeScalar"] = 1}, ["cyanstar"] = { ["Texture"] = [=[SPELLS\CYANSTARFLASH.BLP]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["summon"] = { ["Texture"] = [=[SPELLS\DarkSummon.blp]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["reticle"] = { ["Texture"] = [=[SPELLS\Reticle_128.blp]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0.05, 0.95, 0.05, 0.95 }, ["SizeScalar"] = 1}, ["fuzzyring"] = { ["Texture"] = [=[SPELLS\WHITERINGTHIN128.BLP]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["fatring"] = { ["Texture"] = [=[SPELLS\WhiteRingFat128.blp]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1}, ["swords"] = { ["Texture"] = [=[SPELLS\Strength_128.blp]=], ["Blend"] = _widget.BlendAdd, ["TexCoords"] = { 0, 1, 0, 1 }, ["SizeScalar"] = 1} }

builtins.add_init(function()
	_draw.textureMap["star"] = (_draw.textureMap["marker_1"] or nil)
	_draw.textureMap["circle"] = (_draw.textureMap["marker_2"] or nil)
	_draw.textureMap["diamond"] = (_draw.textureMap["marker_3"] or nil)
	_draw.textureMap["triangle"] = (_draw.textureMap["marker_4"] or nil)
	_draw.textureMap["moon"] = (_draw.textureMap["marker_5"] or nil)
	_draw.textureMap["square"] = (_draw.textureMap["marker_6"] or nil)
	_draw.textureMap["cross"] = (_draw.textureMap["marker_7"] or nil)
	_draw.textureMap["skull"] = (_draw.textureMap["marker_8"] or nil)
end)

