-- Package declaration
local _raidutil = _G["github.com/eandre/groupauras/pkg/raidutil"] or {}
_G["github.com/eandre/groupauras/pkg/raidutil"] = _raidutil

local builtins = _G.lunar_go_builtins

local _luastrings = _G["github.com/eandre/lunar-wow/pkg/luastrings"]
local _luatable = _G["github.com/eandre/lunar-wow/pkg/luatable"]
local _luautil = _G["github.com/eandre/lunar-wow/pkg/luautil"]
local _wow = _G["github.com/eandre/lunar-wow/pkg/wow"]

_raidutil.guidToUnit = {}

_raidutil.GUIDToUnitID = function(guid)
	local uid = (_raidutil.guidToUnit[guid] or "")
	return uid, uid ~= ""
end

_raidutil.guidToUnitUpdate = function(event, args)
	_luatable.Wipe(_raidutil.guidToUnit)
	local update = function(unit)
		local guid = _wow.UnitGUID(unit)
		if (not _luautil.IsNil(guid)) then
			_raidutil.guidToUnit[guid] = unit
		end
	end
	update("player")
	local prefix = "party"
	local inRaid = _wow.IsInRaid()
	if inRaid then
		prefix = "raid"
	end
	local num = _wow.GetNumGroupMembers()
	do
		local i = 1
		while i <= num do
			if i == num and (not inRaid) then
				return
			end
			update((prefix .. _luastrings.ToString(i)))
			i = i + 1
		end
	end
end

builtins.add_init(function()
	_wow.RegisterEvent("GROUP_ROSTER_UPDATE", _raidutil.guidToUnitUpdate)
	_wow.RegisterEvent("RAID_ROSTER_UPDATE", _raidutil.guidToUnitUpdate)
	_wow.RegisterEvent("PLAYER_ENTERING_WORLD", _raidutil.guidToUnitUpdate)
end)

